<login-form>
    <style>
        .inputdiv {
            margin-top: 10px;
            margin-bottom: 0;
        }

        .parsley-success,
        .parsley-success input {
            color: #468847;
            background-color: #DFF0D8;
        }

        .parsley-error,
        .parsley-error input {
            color: #B94A48;
            background-color: #F2DEDE;
        }

        .parsley-errors-list {
            margin: 2px 0 3px;
            padding: 0;
            list-style-type: none;
            font-size: 0.9em;
            line-height: 1.1em;
            color: #B94A48;
            opacity: 1;
            transition: all .3s ease-in;
            -o-transition: all .3s ease-in;
            -moz-transition: all .3s ease-in;
            -webkit-transition: all .3s ease-in;
            max-width: 350px;
        }

        .parsley-errors-list.filled {
            opacity: 1;
        }

        #ulErrorList {
            color: #B94A48;
        }

        #ulErrorList li {
            color: #B94A48;
        }

        .bs-callout-warning {
            /*background-color: #fcf8f2;*/
            border-color: #B94A48/*#f0ad4e*/
            ;
        }

        .bs-callout-warning h4, .bs-callout-warning p.err {
            color: #B94A48/*#f0ad4e*/
            ;
        }

        .bs-callout h4 {
            margin-top: 0;
            margin-bottom: 5px;
        }
    </style>
    <div class="contentdiv">
        <div class="bs-callout bs-callout-warning" if={errorMessage || errors}>
            <h4 if={errors}>Please correct the errors below!</h4>
            <h4 if={errorMessage}>{errorMessage}</h4>
        </div>
        <div style="color:#999;">If you didn't create a username, please use your email address instead.</div>
        <div if={resetPassword}>
            <h4>
                Password was successfuly reset. Please use your new password to login.
            </h4>
        </div>
        <form id="loginForm" class="" method="post" onsubmit={ submitAction }>
            <div class="content">
                <div>
                    <div class="inputdiv" data-id="#userName">
                        <input type="text" ref="userName" placeholder="Username" id="tbUsername"
                               data-parsley-trigger="focusout" data-parsley-length="[6, 100]"
                               data-parsley-required
                               data-parsley-required-message="Please enter your username, or email if you didn't create one yet."/>
                        <span><i class="fa fa-user" aria-hidden="true"></i></span>
                    </div>
                </div>
                <div class="content">
                    <div class="inputdiv" data-id="#password">
                        <input type="password" ref="password" placeholder="Password" data-parsley-trigger="focusout"
                               data-parsley-required data-parsley-required-message="Please enter your password."/>
                        <span><i class="fa fa-lock" aria-hidden="true"></i></span>
                    </div>
                </div>
            </div>
            <div class="contentfooter">
                <button type="submit" class="submitbtn">
                    Submit
                </button><br>
                <a href="forgot-password.html">Forgot Username or Password?</a>
                <a id="urlLink" style="display:none;" href="https://google.com">&nbsp;</a>
                <iframe src="about:blank" style="display:none;" width="1" height="1" id="goif"></iframe>
            </div>
        </form>

    </div>
    <!-- Generate IRS Device ID -->
    <script>
        window.devId = "";
        var fingerprintReport = function () {
            Fingerprint2.get(function (components) {
                var stringtohash = components.map(function (pair) {
                    return pair.value
                }).join('###');
                var fpSHA1 = CryptoJS.SHA1(stringtohash);
                window.devId = fpSHA1.toString();
            })
        }

        var cancelId
        var cancelFunction

        // see usage note in the README
        if (window.requestIdleCallback) {
            cancelId = requestIdleCallback(fingerprintReport)
            cancelFunction = cancelIdleCallback
        } else {
            cancelId = setTimeout(fingerprintReport, 500)
            cancelFunction = clearTimeout
        }
    </script>
    <script>
        var self = this;
        this.errorMessage = "";
        this.resetPassword = false;
        this.errors = "";

        this.on('mount', function () {
            if (this.getParameterByName("changed") == "1") {
                this.resetPassword = true;
                window.setTimeout(function () {
                    riot.update();
                }, 200);
            }
            this.validation = $('#loginForm').parsley({
                classHandler: function (field) {
                    return $(field.$element).parent();
                },
                errorsContainer: function (field) {
                    return $(field.$element).parent().parent();
                }
            }).on('field:validated', function () {
                self.errors = $('.parsley-error').length !== 0;
            });
        });

        eventFire(el, etype) {
            if (el.fireEvent) {
                el.fireEvent('on' + etype);
            } else {
                var evObj = document.createEvent('Events');
                evObj.initEvent(etype, true, false);
                el.dispatchEvent(evObj);
            }
        }

        submitAction(e) {
            console.log("submitting");
            e.preventDefault();
            self.errorMessage = '';
            var username = self.refs.userName.value;
            var password = self.refs.password.value;
            self.resetPassword = false;

            var p = this.validation.validate();
            if (p) {
                const params = {
                    login: username,
                    password: password,
                    source: window.location.hostname,
                    device_id: window.devId,
                    os_app_id: localStorage.getItem("OneSignalAppId"),
                    os_id: localStorage.getItem("OneSignalUserId")
                };
                try {
                    const resp = $.ajax({
                        url: APP_URL + 'api/users/login',
                        crossDomain: true,
                        xhrFields: {
                            withCredentials: true
                        },
                        contentType: 'application/json; charset=utf-8',
                        data: JSON.stringify(params),
                        dataType: 'json',
                        type: 'POST',
                        async: false
                    });

                    if (resp.status === 200) {
                        var add = "";
                        const msclkid = localStorage.getItem("msclkid");
                        if (msclkid && msclkid !== "null") {
                            add = "&msclkid=" + localStorage.getItem("msclkid");
                        }
                        const newUrl = APP_URL + 'land/' + window.location.hostname + '/?t=' + resp.responseJSON.token + add;

                        $("#urlLink").attr("href", newUrl);

                        try {
                            eventFire(document.getElementById('urlLink'), "mousedown");
                        } catch (e) {

                        }

                        window.setTimeout(function () {
                            $("#goif").attr("src", $("#urlLink").attr("href"));
                        }, 200);


                        window.setTimeout(function () {
                            console.log($("#urlLink").attr("href"));
                            window.location.href = $("#urlLink").attr("href");
                        }, 1500);

                        window.setTimeout(function () {
                            window.location.href = newUrl;
                        }, 5000);

                    } else {

                        if (resp.responseJSON && resp.responseJSON.status) {
                            self.errorMessage = resp.responseJSON.detail;
                            Sentry.withScope(function(scope) {
                                scope.setTag("section", "login");
                                scope.setExtra("response", resp);
                                scope.setLevel('warning');
                                Sentry.captureException(new Error(resp.responseJSON.detail));
                            });
                        } else {
                            Sentry.withScope(function(scope) {
                                scope.setTag("section", "login");
                                scope.setExtra("response", resp);
                                scope.setLevel('error');
                                Sentry.captureException(new Error('Server error, please wait a minute and try again'));
                            });
                            self.errorMessage = 'Server error, please wait a minute and try again.';
                        }
                    }
                } catch (err) {
                    Sentry.captureException(err, {
                        tags: {
                            section: "login-global",
                        },
                        level: "error",
                    });
                }

            }
        }
        getParameterByName(name, url) {
            if (!url) {
                url = window.location.href;
            }
            name = name.replace(/[\[\]]/g, "\\$&");
            var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
                results = regex.exec(url);
            if (!results) return null;
            if (!results[2]) return '';
            return decodeURIComponent(results[2].replace(/\+/g, " "));
        }
    </script>
</login-form>
